import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;


public class Main {
    
	private static final int MAXN = 100000;
    
	public static void main(String[] args) throws IOException {
		long st = System.currentTimeMillis();
		new Main().run();
		System.err.println(System.currentTimeMillis() - st);
	}
	
	class Point {
		int x, y;
		int num;
		int orderA;
		boolean exist = true;
		public int orderB;
		Point(String line, int num) {
			String[] h = line.split(" ");
			x = Integer.parseInt(h[0]);
			y = Integer.parseInt(h[1]);
			this.num = num;
		}
	}
	
	class CmpA implements Comparator<Point> {
		public int compare(Point a, Point b) {
			if (a.y != b.y)
				return a.y > b.y ? -1 : 1;
			if (a.x != b.x)
				return a.x > b.x ? -1 : 1;
			return 0;
		}
	}
	
	class CmpB implements Comparator<Point> {
		public int compare(Point a, Point b) {
			if (a.x != b.x)
				return a.x < b.x ? -1 : 1;
			if (a.y != b.y)
				return a.y < b.y ? -1 : 1;
			return 0;
		}
	}
	
	class Rmq {
		private int n;
		private int[] a;
		Rmq(int nn) {
			n = nn;
			a = new int[n * 2];
		}
		void update(int i, int value) {
			i += n;
			a[i] = value;
			while (i > 0) {
				i /= 2;
				a[i] = Math.min(a[i * 2], a[i * 2 + 1]);
			}
		}
		int get(int i, int j) {
			i += n;
			j += n;
			int min = Integer.MAX_VALUE;
			while (i <= j) {
				min = Math.min(min, Math.min(a[i], a[j]));
				i = (i + 1) / 2;
				j = (j - 1) / 2;
			}
			return min;
		}
	}
    
	private void run() throws IOException {
        //		System.setIn(new FileInputStream("input.txt"));
        //		System.setOut(new PrintStream("output.txt"));
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		BufferedWriter out = new BufferedWriter(new OutputStreamWriter(System.out));
		int cnt = Integer.parseInt(in.readLine());
		for (int tst = 1; tst <= cnt; tst++) {
			int n = Integer.parseInt(in.readLine());
			Point[] a = new Point[n];
			Point[] b = new Point[n];
			for (int i = 0; i < n; i++)
				b[i] = a[i] = new Point(in.readLine(), i);
			Arrays.sort(a, new CmpA());
			Arrays.sort(b, new CmpB());
			for (int i = 0; i < n; i++) {
				a[i].orderA = i;
				b[i].orderB = i;
			}
			Rmq rmq = new Rmq(n);
			for (int i = 0; i < n; i++) {
				rmq.update(i, b[i].orderA);
			}
			ArrayList<Integer> res = new ArrayList<Integer>();
			for (int c = n, i = 0; c > 0; i++) {
				if (!a[i].exist)
					continue;
				int cur = i;
				int count = 0;
				while (c > 0) {
					a[cur].exist = false;
					c--;
					count++;
					rmq.update(a[cur].orderB, Integer.MAX_VALUE);
					cur = rmq.get(a[cur].orderB + 1, n - 1);
					if (cur == Integer.MAX_VALUE)
						break;
				}
				res.add(count);
			}
			out.write(res.size() + "\n");
			for (int i = 0; i < res.size(); i++) {
				if (i > 0)
					out.write(" ");
				out.write(res.get(i) + "");
			}
			out.write("\n");
		}
		out.close();
	}
    
}
